#pragma once
#include "pch.h"

#pragma pack (push, 1)	

struct SkyConstantBuffer
{
	float SC_TextureWeight;
	float3 SC_pad1;
};

struct BlurConstantBuffer
{
	float2 B_PixelSize;
	float B_BlurSize;
	float B_Threshold;
};

struct PerObjectState
{
	float3 OS_AmbientColor;
	float OS_Pad;
};

struct PFXVS_ConstantBuffer
{
	D3DXVECTOR4 PFXVS_FrustumCorners[6];
};

struct HeightfogConstantBuffer
{
	D3DXMATRIX InvProj;
	D3DXMATRIX InvView;
	float3 CameraPosition;
	float HF_FogHeight;

	float HF_HeightFalloff;
	float HF_GlobalDensity;
	float2 HF_pad;

	float3 HF_FogColorMod;
	float HF_Pad2;

	float2 HF_ProjAB;
	float2 HF_Pad3;
};

struct LumAdaptConstantBuffer
{
	float LC_DeltaTime;
	float3 LC_Pad;
};

struct HDRSettingsConstantBuffer
{
	float HDR_MiddleGray;
	float HDR_LumWhite;
	float HDR_Threshold;
	float HDR_BloomStrength;
};

struct ViewportInfoConstantBuffer
{
	float2 VPI_ViewportSize;
	float2 VPI_pad;
};

struct DS_PointLightConstantBuffer
{
	float4 PL_Color;			

	float PL_Range;
	float3 Pl_PositionWorld;

	float PL_Pad1;
	float3 Pl_PositionView;

	float2 PL_ViewportSize;
	float2 PL_Pad2;

	D3DXMATRIX PL_InvProj; // Optimize out!
	D3DXMATRIX PL_InvView;

	float3 PL_LightScreenPos;
	float PL_Pad3;
};

struct DS_ScreenQuadConstantBuffer
{
	D3DXMATRIX SQ_InvProj; // Optimize out!
	D3DXMATRIX SQ_InvView;
	float3 SQ_LightDirectionVS;
	float SQ_ShadowmapSize;

	float4 SQ_LightColor;

	D3DXMATRIX SQ_ShadowView;
	D3DXMATRIX SQ_ShadowProj;
};

struct CloudConstantBuffer
{
	float3 C_LightDirection;
	float C_Pad;

	float3 C_CloudPosition;
	float C_Pad2;
};

struct VS_ExConstantBuffer_PerFrame
{
	D3DXMATRIX View;
	D3DXMATRIX Projection;
	D3DXMATRIX ViewProj;
};

struct VS_ExConstantBuffer_PerInstance
{
	D3DXMATRIX World;
};

struct GrassConstantBuffer
{
	float3 G_NormalVS;
	float G_Time;
	float G_WindStrength;
	float3 G_Pad1;
};

struct AtmosphereConstantBuffer
{
	float AC_Kr4PI;
	float AC_Km4PI;	
	float AC_g;
	float AC_KrESun;

	float AC_KmESun;
	float AC_InnerRadius;
	float AC_OuterRadius;
	float AC_Scale;

	float3 AC_Wavelength;
	float AC_RayleighScaleDepth;


	float AC_RayleighOverScaleDepth;
	int AC_nSamples;
	float AC_fSamples;
	float AC_CameraHeight;

	float3 AC_CameraPos;
	float AC_pad1;
	float3 AC_LightPos;
	float AC_pad2;

	float3 AC_SpherePosition;
	float AC_pad3;
};
#pragma pack (pop)