#pragma once

class D3D11ConstantBuffer;
class D3D11VertexBuffer;

class D3D11VShader
{
public:
	D3D11VShader(void);
	~D3D11VShader(void);

	/** Loads both shader at the same time */
	XRESULT LoadShader(const char* vertexShader, int layoput = 1);

	/** Applys the shader */
	XRESULT Apply();

	/** Returns a reference to the constantBuffer vector*/
	std::vector<D3D11ConstantBuffer*>& GetConstantBuffer();
private:

	/** Compiles a shader from file and outputs error messages if needed */
	HRESULT CompileShaderFromFile(const CHAR* szFileName, LPCSTR szEntryPoint, LPCSTR szShaderModel, ID3DBlob** ppBlobOut);

	ID3D11VertexShader* VertexShader;
	ID3D11InputLayout* InputLayout;
	std::vector<D3D11ConstantBuffer*> ConstantBuffers;

	std::string File;
};

