#pragma once
#include "pch.h"

class GMeshSimple;
class BaseTexture;
class BaseConstantBuffer;
class BaseVertexBuffer;
class zCTexture;
struct MeshInfo;
class GVegetationBox
{
public:
	GVegetationBox(void);
	virtual ~GVegetationBox(void);

	enum EShape
	{
		S_None,
		S_Box,
		S_Circle
	};

	/** Initializes the vegetationbox */
	XRESULT InitVegetationBox(	const D3DXVECTOR3& min, 
								const D3DXVECTOR3& max, 
								const std::string& vegetationMesh, 
								float density, 
								float maxSize,
								const std::string& restrictByTexture = "",
								EShape shape = S_Box);

	XRESULT InitVegetationBox(  MeshInfo* mesh, 
								const std::string& vegetationMesh,
								float density, 
								float maxSize,
								zCTexture* meshTexture = NULL);

	/** Draws this vegetation box */
	void RenderVegetation(const D3DXVECTOR3& eye);

	/** Returns true if the given position is inside the box */
	bool PositionInsideBox(const D3DXVECTOR3& p);

	/** Sets bounding box rendering */
	void SetRenderBoundingBox(bool value);

private:
	/** Puts trasformation for the given spots */
	void InitSpotsRandom(const std::vector<D3DXVECTOR3>& trisInside, EShape shape = S_None);

	std::vector<D3DXMATRIX> VegetationSpots;
	GMeshSimple* VegetationMesh;
	zCTexture* MeshTexture;
	D3DXVECTOR3 BoxMin;
	D3DXVECTOR3 BoxMax;
	BaseTexture* VegetationTexture;
	BaseVertexBuffer* InstancingBuffer;
	BaseConstantBuffer* GrassCB;
	bool DrawBoundingBox;
};

