#include "pch.h"
#include "HookedFunctions.h"

#include "zCBspTree.h"
#include "zCWorld.h"
#include "oCGame.h"
#include "zCMaterial.h"
#include "zFILE.h"
#include "zCOption.h"
#include "zCRndD3D.h"
#include "zCParticleFX.h"
#include "zCView.h"
#include "CGameManager.h"
#include "zCVisual.h"

/** Init all hooks here */
void HookedFunctionInfo::InitHooks()
{
	LogInfo() << "Initializing hooks";

	DWORD dwProtect;
	VirtualProtect((void *)GothicMemoryLocations::zCWorld::Render, 0x255, PAGE_EXECUTE_READWRITE, &dwProtect);

	oCGame::Hook();
	zCBspTree::Hook();
	zCWorld::Hook();
	zCMaterial::Hook();
	zCBspNode::Hook();
	zFILE::Hook();
	zCOption::Hook();
	zCRndD3D::Hook();
	zCParticleFX::Hook();
	zCView::Hook();
	CGameManager::Hook();
	zCVisual::Hook();

	original_HandledWinMain = (HandledWinMain)DetourFunction((BYTE *)GothicMemoryLocations::Functions::HandledWinMain, (BYTE *)HookedFunctionInfo::hooked_HandledWinMain);
	//original_ExitGameFunc = (ExitGameFunc)DetourFunction((BYTE *)GothicMemoryLocations::Functions::ExitGameFunc, (BYTE *)HookedFunctionInfo::hooked_ExitGameFunc);

	original_Alg_Rotation3DNRad = (Alg_Rotation3DNRad)GothicMemoryLocations::Functions::Alg_Rotation3DNRad;
}

/** Function hooks */
int __stdcall HookedFunctionInfo::hooked_HandledWinMain(HINSTANCE hInstance, HINSTANCE hPrev, LPSTR szCmdLine, int sw)
{
	int r = HookedFunctions::OriginalFunctions.original_HandledWinMain(hInstance, hPrev, szCmdLine, sw);

	return r;
}

void __cdecl HookedFunctionInfo::hooked_ExitGameFunc()
{
	Engine::OnShutDown();

	HookedFunctions::OriginalFunctions.hooked_ExitGameFunc();
}