//--------------------------------------------------------------------------------------
// World/VOB-Pixelshader for G2D3D11 by Degenerated
//--------------------------------------------------------------------------------------

#include <hdr.h>

//--------------------------------------------------------------------------------------
// Textures and Samplers
//--------------------------------------------------------------------------------------
SamplerState SS_Linear : register( s0 );
SamplerState SS_samMirror : register( s1 );
Texture2D	TX_Scene : register( t0 );
Texture2D	TX_Lum : register( t1 );
Texture2D	TX_Bloom : register( t2 );



//--------------------------------------------------------------------------------------
// Input / Output structures
//--------------------------------------------------------------------------------------
struct PS_INPUT
{
	float2 vTexcoord		: TEXCOORD0;
	float3 vEyeRay			: TEXCOORD1;
	float4 vPosition		: SV_POSITION;
};


//--------------------------------------------------------------------------------------
// Pixel Shader
//--------------------------------------------------------------------------------------
float4 PSMain( PS_INPUT Input ) : SV_TARGET
{
	float4 sample = TX_Scene.Sample(SS_Linear, Input.vTexcoord);
	float3 HDRColor = sample.rgb;
	//HDRColor = float3(Input.vTexcoord.r, 0, 0);
	
	float3 toneMapped = ToneMap(HDRColor, TX_Lum, SS_Linear);
	
	float3 bloom = TX_Bloom.Sample(SS_Linear, Input.vTexcoord).rgb;

	//return float4(sample.rgb, 1);
	//return float4(TX_Lum.SampleLevel(SS_Linear, float2(0.5f, 0.5f), 10).rrr,1);
	return float4(pow(toneMapped + bloom * HDR_BloomStrength, 2.2f), 1); 
}

