#pragma once
#include "pch.h"
#include "HookedFunctions.h"
#include "Engine.h"
#include "GothicAPI.h"
#include "BaseGraphicsEngine.h"

class zCOption
{
public:

	/** Hooks the functions of this Class */
	static void Hook()
	{
		HookedFunctions::OriginalFunctions.original_zCOptionReadInt = (zCOptionReadInt)DetourFunction((BYTE *)GothicMemoryLocations::zCOption::ReadInt, (BYTE *)zCOption::hooked_zOptionReadInt);
		HookedFunctions::OriginalFunctions.original_zCOptionReadBool = (zCOptionReadInt)DetourFunction((BYTE *)GothicMemoryLocations::zCOption::ReadBool, (BYTE *)zCOption::hooked_zOptionReadBool);

	}

	/** Reads config stuff */
	static int __fastcall hooked_zOptionReadBool(void* thisptr, void* unknwn,zSTRING const& section, char const* var, int def)
	{
		if(strcmp(var, "zWaterAniEnabled") == 0)
		{
			return 0; // Disable water animations
		}

		return HookedFunctions::OriginalFunctions.original_zCOptionReadBool(thisptr, section, var, def);
	}

	/** Reads config stuff */
	static long __fastcall hooked_zOptionReadInt(void* thisptr, void* unknwn,zSTRING const& section, char const* var, int def)
	{
		BaseGraphicsEngine* engine = Engine::GraphicsEngine;
		LogInfo() << "Reading Gothic-Config: " << var;

		if(strcmp(var, "zVidResFullscreenX") == 0)
		{
			LogInfo() << "Forcing zVidResFullscreenX: " << engine->GetResolution().x;
			return engine->GetResolution().x;
		}else if(strcmp(var, "zVidResFullscreenY") == 0)
		{
			LogInfo() << "Forcing zVidResFullscreenY: " << engine->GetResolution().y;
			return engine->GetResolution().y;
		}else if(strcmp(var, "zVidResFullscreenBPP") == 0)
		{
			return 32;
		}else if(strcmp(var, "zTexMaxSize") == 0)
		{
			return 16384;
		}

		return HookedFunctions::OriginalFunctions.original_zCOptionReadInt(thisptr, section, var, def);
	}
};



