#pragma once
#include "pch.h"
#include "HookedFunctions.h"
#include "zCPolygon.h"
#include "Engine.h"
#include "GothicAPI.h"
#include "zCTimer.h"

class zSTRING;
class zCPolyStrip;
class zCMesh;
struct zTParticle 
{
	zTParticle* Next;
	D3DXVECTOR3	Position; // local
	D3DXVECTOR3	PositionWS;
	D3DXVECTOR3	Vel;
	float LifeSpan;
	float Alpha;
	float AlphaVel;
	D3DXVECTOR2	Size;
	D3DXVECTOR2	SizeVel;
	D3DXVECTOR3	Color;
	D3DXVECTOR3	ColorVel;
	zCPolyStrip* PolyStrip; // TODO: Use this too
};

class zCParticleEmitter 
{
public:
	float					ppsValue;
	zSTRING					ppsScaleKeys_S;
	int						ppsIsLooping;
	int						ppsIsSmooth;
	float					ppsFPS;
	zSTRING					ppsCreateEm_S;
	float					ppsCreateEmDelay;
	zSTRING					shpType_S;					
	zSTRING					shpFOR_S;					
	zSTRING					shpOffsetVec_S;				
	zSTRING					shpDistribType_S;			
	float					shpDistribWalkSpeed;	
	int						shpIsVolume;
	zSTRING					shpDim_S;			
	zSTRING					shpMesh_S;					
	int						shpMeshRender_B;
	zSTRING					shpScaleKeys_S;				
	int						shpScaleIsLooping;
	int						shpScaleIsSmooth;
	float					shpScaleFPS;
	zSTRING					dirMode_S;					
	zSTRING					dirFOR_S;					
	zSTRING					dirModeTargetFOR_S;
	zSTRING					dirModeTargetPos_S;			
	float					dirAngleHead;
	float					dirAngleHeadVar;
	float					dirAngleElev;
	float					dirAngleElevVar;
	float					velAvg;
	float					velVar;
	float					lspPartAvg;
	float					lspPartVar;
	zSTRING					flyGravity_S;
	int						flyCollDet_B;
	zSTRING					visName_S;					
	zSTRING					visOrientation_S;
	int						visTexIsQuadPoly;			
	float					visTexAniFPS;
	int						visTexAniIsLooping;					
	zSTRING					visTexColorStart_S;
	zSTRING					visTexColorEnd_S;
	zSTRING					visSizeStart_S;
	float					visSizeEndScale;
	zSTRING					visAlphaFunc_S;
	float					visAlphaStart;
	float					visAlphaEnd;
	float					trlFadeSpeed;
	zSTRING					trlTexture_S;
	float					trlWidth;
	float					mrkFadeSpeed;
	zSTRING					mrkTexture_S;
	float					mrkSize;
	zSTRING					m_flockMode_S;
	float					m_fFlockWeight;
	int						m_bSlowLocalFOR;
	zSTRING					m_timeStartEnd_S;
	int						m_bIsAmbientPFX;
	int						endOfDScriptPart;
	zSTRING					particleFXName;				
	zCArray<float>			ppsScaleKeys;
	zCParticleEmitter		*ppsCreateEmitter;
	int						shpType;					
	float					shpCircleSphereRadius;
	D3DXVECTOR3				shpLineBoxDim;
	D3DXVECTOR3*			shpMeshLastPolyNormal;
	zCMesh					*shpMesh;
	zCProgMeshProto			*shpProgMesh;
	zCModel					*shpModel;
	int						shpFOR;
	int						shpDistribType;
	D3DXVECTOR3				shpOffsetVec;
	zCArray<float>			shpScaleKeys;			
	int						dirMode;				
	int						dirFOR;					
	int						dirModeTargetFOR;
	D3DXVECTOR3				dirModeTargetPos;		
	zTBBox3D				dirAngleBox;
	D3DXVECTOR3				dirAngleBoxDim;
	D3DXVECTOR3				flyGravity;
	zCTexture				*visTexture;
	int						visOrientation;
	D3DXVECTOR2				visSizeStart;
	D3DXVECTOR3				visTexColorRGBAStart;
	D3DXVECTOR3				visTexColorRGBAEnd;
	zTRnd_AlphaBlendFunc	visAlphaFunc;
	zCTexture				*trlTexture;
	zCTexture				*mrkTexture;
	int						isOneShotFX;
	float					dirAngleHeadVarRad;
	float					dirAngleElevVarRad;
	int						m_flockMode;
	float					m_ooAlphaDist;
	float					m_startTime;
	float					m_endTime;

	zCTexture* GetVisTexture()
	{	
		return *(zCTexture **)THISPTR_OFFSET(GothicMemoryLocations::zCParticleEmitter::Offset_VisTexture); 
	}

	zTRnd_AlphaBlendFunc GetVisAlphaFunc()
	{
		return *(zTRnd_AlphaBlendFunc *)THISPTR_OFFSET(GothicMemoryLocations::zCParticleEmitter::Offset_VisAlphaBlendFunc); 
	}
};

class zCStaticPfxList 
{
public:
	void TouchPfx(zCParticleFX *pfx)
	{
		XCALL(GothicMemoryLocations::zCStaticPfxList::TouchPFX);
	}
};

class zCParticleFX
{
public:
	zCParticleFX(void);
	~zCParticleFX(void);

	/** Hooks the functions of this Class */
	static void Hook()
	{
		HookedFunctions::OriginalFunctions.original_zCParticleFXDestructor = (GenericDestructor)DetourFunction((BYTE *)GothicMemoryLocations::zCParticleFX::Destructor, (BYTE *)zCParticleFX::Hooked_Destructor);
	}
	 
	static void __fastcall Hooked_Destructor(void* thisptr, void* unknwn)
	{
		// Notify the world
		if(Engine::GAPI)
			Engine::GAPI->OnParticleFXDeleted((zCParticleFX *)thisptr);

		HookedFunctions::OriginalFunctions.original_zCParticleFXDestructor(thisptr);
	}

	zCParticleEmitter* GetEmitter()
	{
		return *(zCParticleEmitter **)THISPTR_OFFSET(GothicMemoryLocations::zCParticleFX::Offset_Emitters); 
	}

	zTParticle* GetFirstParticle()
	{
		return *(zTParticle **)THISPTR_OFFSET(GothicMemoryLocations::zCParticleFX::Offset_FirstParticle); 
	}

	zCVob* GetConntectedVob()
	{
		return *(zCVob **)THISPTR_OFFSET(GothicMemoryLocations::zCParticleFX::Offset_ConnectedVob); 
	}

	float GetTimeScale()
	{
		return *(float *)THISPTR_OFFSET(GothicMemoryLocations::zCParticleFX::Offset_TimeScale); 
	}

	float* GetPrivateTotalTime()
	{
		return (float *)THISPTR_OFFSET(GothicMemoryLocations::zCParticleFX::Offset_PrivateTotalTime); 
	}

	int UpdateParticleFX()
	{
		XCALL(GothicMemoryLocations::zCParticleFX::UpdateParticleFX);
	}

	bool IsRemoved()
	{
		zCParticleFX* next = *(zCParticleFX **)THISPTR_OFFSET(GothicMemoryLocations::zCParticleFX::Offset_NextPFX); 
		zCParticleFX* prev = *(zCParticleFX **)THISPTR_OFFSET(GothicMemoryLocations::zCParticleFX::Offset_PrevPFX); 

		// The remove-function sets these two to NULL
		return prev == NULL && next == NULL;
	}
	
	/*zCStaticPfxList* GetStaticPFXList()
	{
		return *(zCStaticPfxList **)GothicMemoryLocations::zCParticleFX::OBJ_s_pfxList;
	}*/

	void SetLocalTimeF(float t)
	{
		*(float *)THISPTR_OFFSET(GothicMemoryLocations::zCParticleFX::Offset_LocalFrameTimeF) = t;
	}

	void UpdateTime()
	{
		SetLocalTimeF(GetTimeScale() * zCTimer::GetTimer()->frameTimeFloat);
	}

	void CreateParticlesUpdateDependencies()
	{
		XCALL(GothicMemoryLocations::zCParticleFX::CreateParticlesUpdateDependencies);
	}

	void UpdateParticle(zTParticle* p)
	{
		XCALL(GothicMemoryLocations::zCParticleFX::UpdateParticle);
	}

	void SetVisualUsedBy(zCVob* vob)
	{
		XCALL(GothicMemoryLocations::zCParticleFX::SetVisualUsedBy);
	}
};

