#pragma once
#include "pch.h"
#include "HookedFunctions.h"
#include "Engine.h"
#include "GothicAPI.h"
#include "zCResourceManager.h"
#include "zSTRING.h"

class zCTexture
{
public:
	zCTexture(void);
	~zCTexture(void);


	const char* GetName()
	{
		return __GetName().ToChar();
	}

	std::string GetNameWithoutExt()
	{
		std::string n = GetName();
		n.resize(n.size() - 4);

		return n;
	}


	void Bind(int slot = 0)
	{
		Engine::GAPI->SetBoundTexture(slot, this);

		_Bind(0, slot);
	}

	void _Bind(bool unkwn, int stage = 0)
	{
		XCALL(GothicMemoryLocations::zCTexture::zCTex_D3DInsertTexture);
	}
	
	int LoadResourceData()
	{
		XCALL(GothicMemoryLocations::zCTexture::LoadResourceData);
	}

	zTResourceCacheState GetCacheState()
	{
		unsigned char state = *(unsigned char *)THISPTR_OFFSET(GothicMemoryLocations::zCTexture::Offset_CacheState);

		return (zTResourceCacheState)(state & GothicMemoryLocations::zCTexture::Mask_CacheState);
	}

	zTResourceCacheState CacheIn(float priority)
	{
		if (GetCacheState()==zRES_CACHED_IN)
		{
			TouchTimeStamp();
		} else 
		{
			TouchTimeStampLocal();
			zCResourceManager::GetResourceManager()->CacheIn(this, priority);
		}

		return GetCacheState();
	}

	void TouchTimeStamp()
	{
		XCALL(GothicMemoryLocations::zCTexture::zCResourceTouchTimeStamp);
	}

	void TouchTimeStampLocal()
	{
		XCALL(GothicMemoryLocations::zCTexture::zCResourceTouchTimeStampLocal);
	}

	void Release()
	{
		XCALL(GothicMemoryLocations::zCObject::Release);
	}

/*#ifdef BUILD_GOTHIC_1_08k
	zCTexture* GetAniTexture()
	{
		XCALL(GothicMemoryLocations::zCTexture::GetAniTexture);
	}
#endif*/

private:
	const zSTRING& __GetName()
	{
		XCALL(GothicMemoryLocations::zCTexture::GetName);
	}
};

